import { Provider } from "zksync-ethers";
import { ConstructorParamMap, ContractOptions, DeployedContractType } from "../types/any-evm/deploy-data";
import { ThirdwebStorage } from "@thirdweb-dev/storage";
import { BytesLike } from "ethers";
import { PreDeployMetadataFetched } from "../schema/contracts/custom";
import { DeploymentPreset } from "./types/deploy-data";
export declare function zkComputeDeploymentInfo(contractType: DeployedContractType, provider: Provider, storage: ThirdwebStorage, create2Factory: string, contractOptions?: ContractOptions, clientId?: string, secretKey?: string): Promise<DeploymentPreset>;
/**
 * @internal
 *
 * Determine constructor params required by an implementation contract.
 * Return abi-encoded params.
 */
export declare function encodeConstructorParamsForImplementation(compilerMetadata: PreDeployMetadataFetched, provider: Provider, constructorParamMap?: ConstructorParamMap): Promise<{
    encodedArgs: BytesLike;
    params: any[];
}>;
//# sourceMappingURL=zkComputeDeploymentInfo.d.ts.map